package com.adaptrex.core.persistence.api;

import java.util.Map;

import com.adaptrex.core.ext.ExtConfig;

public interface ORMPersistenceManager {

	public Object getFactory();
	public Object getSession();
	public ORMModelDefinition getModelDefinition(ExtConfig extConfig);
	public void shutdown();
	public Class<?> getEntityClass(String className);
	public boolean isManyToOne(Class<?> clazz, String fieldName);
	public boolean isOneToMany(Class<?> clazz, String fieldName);
	public boolean isIdField(Class<?> clazz, String fieldName);
	public String getFieldType(Class<?> clazz, String fieldName);
	public boolean isManyToMany(Class<?> clazz, String fieldName);
	public boolean isAssociated(Class<?> clazz, String associationName);
	public Class<?> getFieldEntityClass(Class<?> clazz, String fieldName);
	public ORMModelInstance getModelInstance(ExtConfig extConfig, Object entity);
	public Object getEntity(Class<?> clazz, Object id);
	public Object getEntity(Class<?> clazz, String key, Object value);
	public Object getFieldValue(Object entity, String fieldName);
	public Object getEntityId(Object entity);
	public ORMStoreData getStoreData(ExtConfig extConfig);
	
	public ORMModelInstance createModelinstance(ExtConfig extConfig, Map<String,Object> data);
	public ORMModelInstance updateModelInstance(ExtConfig extConfig, Object id, Map<String,Object> data);
	public ORMModelInstance deleteModelInstance(ExtConfig extConfig, Object id);
}
  