package com.adaptrex.core.rest;

import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;

import com.adaptrex.core.services.AdaptrexServices;

public class AdaptrexRestApi {

	@Context protected UriInfo uriInfo;
	private String modelName;
	
    @GET
    public RestStore getStore() {
    	return AdaptrexServices.getRestService().getStore(this.modelName, uriInfo);
    }

    @GET @Path("{id}")
    public RestModel getModel(@PathParam("id") Integer id) {
    	return AdaptrexServices.getRestService().getModel(this.modelName, id, uriInfo);
    }
    
    @POST
    public RestModel createModel(RequestBody modelUpdate) {
    	return AdaptrexServices.getRestService().createModel(this.modelName, modelUpdate, uriInfo);
    }
    
    @PUT @Path("{id}")
    public RestModel updateModel(@PathParam("id") Integer id, RequestBody modelUpdate) {
    	return AdaptrexServices.getRestService().updateModel(this.modelName, id, modelUpdate, uriInfo);
    }

    @DELETE @Path("{id}")
    public RestModel deleteModel(@PathParam("id") Integer id) {
    	return AdaptrexServices.getRestService().deleteModel(this.modelName, id);
    }
    
    public void setModelName(String modelName) {
    	this.modelName = modelName;
    }
	
}
