package com.adaptrex.core.view.jsf;

import java.io.IOException;
import java.util.Map;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import com.adaptrex.core.AdaptrexConfig;
import com.adaptrex.core.view.ConfigComponent;

@FacesComponent("ext.data.Config") 
public class JSFConfigComponent extends UIComponentBase {
	
	@Override
	public String getFamily() {
		return "ext.data.config";
	}
	
	@Override
    public void encodeBegin(FacesContext context) throws IOException {
		ExternalContext external = context.getExternalContext();
		HttpServletRequest request = (HttpServletRequest) external.getRequest();
		
		Map<String,Object> a = getAttributes();
		String webLib			= (String) a.get(AdaptrexConfig.WEBLIB);
		String extVersion		= (String) a.get(AdaptrexConfig.EXT_VERSION);
		String extBuild			= (String) a.get(AdaptrexConfig.EXT_BUILD);
		String extPath			= (String) a.get(AdaptrexConfig.EXT_PATH);
		String extTheme			= (String) a.get(AdaptrexConfig.EXT_THEME);
		
		String touchVersion		= (String) a.get(AdaptrexConfig.SENCHATOUCH_VERSION);
		String touchPath		= (String) a.get(AdaptrexConfig.SENCHATOUCH_PATH);
		String touch			= (String) a.get("touch");
		
		
		String namespace = (String) a.get(AdaptrexConfig.EXT_NAMESPACE);
		if (namespace == null) namespace = (String) a.get("ns");
		if (namespace == null) namespace = (String) a.get("namespace");
		if (namespace != null) {
			request.setAttribute("adaptrex_namespace", namespace);
    	}
		
		ConfigComponent configComponent = new ConfigComponent(request);
		configComponent.setNamespace(namespace);
		
		if (webLib != null)		configComponent.setWeblibPath(webLib);
		if (extVersion != null)	configComponent.setExtVersion(extVersion);
		if (extBuild != null)	configComponent.setExtBuild(extBuild);
		if (extPath != null)	configComponent.setExtPath(extPath);
		if (extTheme != null)	configComponent.setExtTheme(extTheme);
		
		if (touchVersion != null)	configComponent.setSenchaTouchVersion(touchVersion);
		if (touchPath != null)		configComponent.setSenchaTouchPath(touchPath);
		if (touch != null && touch.equals("true")) {
			configComponent.setTouch(true);
			request.setAttribute("adaptrex_touch", true);
		}
		
		context.getResponseWriter().write(configComponent.toString());
	}
}
 