package com.adaptrex.core.view.jsf;

import java.io.IOException;
import java.util.Map;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import com.adaptrex.core.AdaptrexConfig;
import com.adaptrex.core.view.ModelComponent;

@FacesComponent("ext.data.Model") 
public class JSFModelComponent extends UIComponentBase {

	@Override
	public String getFamily() {
		return "ext.data.model";
	}
	
	@Override
    public void encodeBegin(FacesContext context) throws IOException {
		ExternalContext external = context.getExternalContext();
		HttpServletRequest request = (HttpServletRequest) external.getRequest();
		
		Map<String,Object> a = getAttributes();
		String factory 				= (String) a.get("factory");
		String table 				= (String) a.get("table");
		String modelName 			= (String) a.get("name");
		String include 				= (String) a.get("include");
		String exclude	 			= (String) a.get("exclude");
		String associations			= (String) a.get("associations");
		String entityId				= (String) a.get("entityid");
		String entityKey			= (String) a.get("entitykey");
		String entityValue			= (String) a.get("entityvalue");
		String rest					= (String) a.get("rest");
		
		String namespace = (String) a.get(AdaptrexConfig.EXT_NAMESPACE);
		if (namespace == null) namespace = (String) a.get("ns");
		if (namespace == null) namespace = (String) a.get("namespace");
		if (namespace == null) {
			namespace = (String) request.getAttribute("adaptrex_namespace");
		}
		
		ModelComponent modelComponent = new ModelComponent(request, table, factory);
		modelComponent.setNamespace(namespace);
		
		if (modelName != null)		modelComponent.setModelName(modelName);
		if (include != null)		modelComponent.setInclude(include);
		if (exclude != null)		modelComponent.setExclude(exclude);
		if (associations != null) 	modelComponent.setAssociations(associations);
		if (entityId != null)		modelComponent.setEntityId(entityId);
		if (entityKey != null)		modelComponent.setEntityKey(entityKey);
		if (entityValue != null)	modelComponent.setEntityValue(entityValue);
		
		if (rest != null && !rest.equals("false"))	{
			modelComponent.setRest(rest);
		}
		
		context.getResponseWriter().write(modelComponent.toString());
	}
}
